varying vec3 normal, lightDir0, lightDir1, eyeVec;
uniform sampler2D tex_c; //0 = ColorMap, 1 = NormalMap
uniform sampler2D tex_n; //0 = ColorMap, 1 = NormalMap
varying vec3 vVertex;

void main (void)
{
    
    
    
    vec4 texColor = texture2D(tex_c, gl_TexCoord[0].st).rgba;
 	
	vec3 norm = normalize(texture2D(tex_n, gl_TexCoord[0].st).rgb * 2.0 - 1.0);
		
	
	vec4 final_color = (gl_FrontLightModelProduct.sceneColor * vec4(texColor.rgb,1.0)) +
	(gl_LightSource[0].ambient * vec4(texColor.rgb,1.0)) +
	(gl_LightSource[1].ambient * vec4(texColor.rgb,1.0));

	vec3 N = normalize(norm);
	vec3 L0 = normalize(lightDir0);
	vec3 L1 = normalize(lightDir1);
	
	float attenuation;
	float d;
	vec3 lightVec;
	
	lightVec = (vec3(gl_LightSource[0].position) - vVertex);
	
	d =length(lightVec);

	attenuation = 1.0 / (gl_LightSource[0].constantAttenuation +
	gl_LightSource[0].linearAttenuation * d +
	gl_LightSource[0].quadraticAttenuation * d * d);
	
	
	float lambertTerm0 = dot(N,L0);
	float lambertTerm1 = dot(N,L1);

	if(lambertTerm0 > 0.0)
	{
		final_color += gl_LightSource[0].diffuse *
		               gl_FrontMaterial.diffuse *
					   lambertTerm0 * attenuation;

		vec3 E = normalize(eyeVec);
		vec3 R = reflect(-L0, N);
		float specular = pow( max(dot(R, E), 0.0),
		                 gl_FrontMaterial.shininess );
		final_color += gl_LightSource[0].specular *
		               gl_FrontMaterial.specular *
					   specular * attenuation;
	}


	
	lightVec = (vec3(gl_LightSource[1].position) - vVertex);
	
	d =length(lightVec);

	attenuation = 1.0 / (gl_LightSource[1].constantAttenuation +
	gl_LightSource[1].linearAttenuation * d +
	gl_LightSource[1].quadraticAttenuation * d * d);





	if(lambertTerm1 > 0.0)
	{
		final_color += gl_LightSource[1].diffuse *
		               gl_FrontMaterial.diffuse *
					   lambertTerm1  * attenuation;

		vec3 E = normalize(eyeVec);
		vec3 R = reflect(-L1, N);
		float specular = pow( max(dot(R, E), 0.0),
		                 gl_FrontMaterial.shininess );
		final_color += gl_LightSource[1].specular *
		               gl_FrontMaterial.specular *
					   specular  * attenuation;
	}
	
	gl_FragColor = vec4(final_color.rgb,0.9);
}